function ConvolutionTest()

taps = 2:50;
signalLen = [1e4 1e5 1e6];

t = zeros(length(signalLen),length(taps));
f = zeros(length(signalLen),length(taps));


coeffs = rand(taps(end),1)*2 - 1;
signal = rand(max(signalLen),1)*2 - 1;


for j = 1:length(signalLen)
    for i = 1:length(taps)
        clear filtered_signal;
        [filtered_signal, t(j,i)] = convolution(coeffs(1:taps(i)), signal(1:signalLen(j)));
        f(j,i) = signalLen(j)/t(j,i);
    end
end


plot(taps,f,'s')
%%
xlabel('Filter length')
ylabel('Samples per second')
legend('10k samples','100k samples', '1M samples', '10M samples')
