%load data
load pulse.mat
load ac.mat
c0 = 1560;

fs = 40e6;
fc = 10e6;
fs_up = 16*fc;
beams = 10;
channels = length(ac);


% samples = 512;
% depth = 0.5*c0*samples/fs
depth = 0.05;
samples = round(2*depth*fs/c0)


focusDepth = 0.7*depth;


data = zeros(samples,channels*beams);



pulseLen = length(pulse_up)*fs/fs_up;
pulse_up_i = linspace(1,pulseLen,length(pulse_up));
pulse_i = 1:pulseLen;

%%


% get point scatterers
[x y] = genPointsGPU(depth);
length(x)
plot(x,y,'.')
%%

% generate angles for 60 degree sweep
theta = pi*linspace(-30,30,beams)/180;

% transmit beam apodization
apodization = hann(channels);
% apodization = ones(channels,1);


for b = 1:beams
    % get the amplitude of the transmit beam at the given points
    pointAmps = getAmplitude(x,y,ac,apodization,theta(b),fc,c0,focusDepth);
    b
    for c = 1:channels
        % get the time the echo from the points hits this element
        pointDelays = getDelays(x,y,ac(c),c0);
        
        % convert to sample indices
        pointIndex = round(pointDelays*fs);
        pointIndexFrac = pointIndex-pointDelays*fs;
        
        chanIdx = (b-1)*channels + c;
        
        for n = 1:length(pointIndex)
            i = pointIndex(n);
            d = pointIndexFrac(n);
            data(i+(1:pulseLen), chanIdx) = ...
                data(i+(1:pulseLen), chanIdx ) + ...
                pointAmps(n)*interp1( pulse_up_i, pulse_up, pulse_i+d, 'linear',0)';
        end
        
    end
end

data = data./max(max(abs(data)));
%%

% out_data = linearDelayAndSumOpt( data, ac, fs, c0, theta);
no_mla = 7;
o = (theta(2)-theta(1))/no_mla;
thetaMLA = [theta-3*o; theta-2*o; theta-o;theta;theta+o;theta+2*o;theta+3*o];
out_data = TEXF_MLA( data, ac, fs, c0, thetaMLA);

% 
% dataUp = Up4x(data);
% out_data = quarterTEXF_MLA( dataUp, ac, fs, c0, theta);

sweepimage(out_data, thetaMLA(:), depth, 200)

