function sweepimage(in_data, theta, depth, res)

beams = length(theta);
samples = size(in_data,1);

radiusRes = ceil(samples/round(samples/res));
image = zeros(beams,radiusRes);

for n = 1:beams
    image(n,:) = decimate(abs(hilbert(in_data(:,n))),round(samples/res));
end
radius = linspace(0,depth,radiusRes);
[TH,R] = meshgrid(theta,radius);
[X,Y] = pol2cart(TH,R);
surface(X,Y,image','EdgeColor','none')
colormap('gray')
shading interp
