%load data
load long_pulse.mat
load ac.mat
c0 = 1560;
%%

fs = 40e6;
fc = 10e6;
fs_up = 16*fc;
channels = 128;

samples = 512;
depth = 0.5*c0*samples/fs
% depth = 0.30;
% samples = round(2*depth*fs/c0)

apo = createApo(samples,channels,0.1,1);

pulseLen = length(pulse_up)*fs/fs_up;
pulse_up_i = linspace(1,pulseLen,length(pulse_up));
pulse_i = 1:pulseLen;


%%

theta = 0;
Xres = 100;
Yres = 40;
ampSum = zeros(Xres,Yres);
ampMax = zeros(Xres,Yres);
d = depth*0.7;
[X,Y] = meshgrid(linspace(0,d,Xres), linspace(-d/10,d/10,Yres));

K=11;
coeffs = [delay_filter( -0.25, 40, K, fs, fc) ...
          delay_filter( -0.5, 40, K, fs, fc) ...
          delay_filter( -0.75, 40, K, fs, fc)];

for xi = Xres:-1:1
    for yi = 1:Yres
        x = X(yi,xi)
        y = Y(yi,xi)
        data = zeros(samples,channels);
        for c = 1:channels
            % get the time the echo from the points hits this element
            pointDelays = getDelays(x,y,ac(c),c0);

            % convert to sample indices
            pointIndex = round(pointDelays*fs);
            pointIndexFrac = pointIndex-pointDelays*fs;

            for n = 1:length(pointIndex)
                i = pointIndex(n);
                d = pointIndexFrac(n);
                data(i+(1:pulseLen), c) = ...
                    data(i+(1:pulseLen), c ) + ...
                    interp1( pulse_up_i, pulse_up, pulse_i+d, 'spline',0)';
            end

        end
        if(max(max(abs(data))) > 1)
            data_overflow = max(max(abs(data)))
        end
        
%         data_up = Upsample4x(data, coeffs);
%         out_data_up = linearDelayAndSumOpt( data_up, ac, fs*4, c0, theta);
%         out_data = out_data_up(1:4:end);
        out_data = TEXF( data, ac, fs, c0, theta);
%         out_data = TEXF_APO( data, ac, fs, c0, theta, apo);
        ampSum(xi,yi) = sum(abs(out_data));
        ampMax(xi,yi) = max(abs(out_data));
    end
end
    
%%
figure
surface(X,Y,ampSum')
shading interp
figure
surface(X,Y,ampMax')
shading interp


