block_size = 128; % defined in TEXF.cu

load ac;
fs = 40e6;
c0 = 1560;

beams = 1:1:40;
samples = (1:16)*block_size;

t = zeros(length(beams),length(samples));

for i = 1:length(beams)
    for j = 1:length(samples)
        [dummy, t(i,j)] = TEXF(zeros(samples(j),length(ac)*beams(i)), ac,fs,c0, zeros(beams(i),1));
    end
end
%%

blocks = samples/block_size;
contour(beams,samples,blocks'*beams,1:16*6:1000);
hold on
surf(beams-1,samples-block_size,-t')


set(gca,'ytick',samples);
set(gca,'xtick',5:5:40);
xlim([0 39]);
ylim([0 128*15]);

xlabel('Beams')
ylabel('Samples')
zlabel('samples per second')