function verifyUpsample4x
fs = 40e6;
fc = 10e6;
K = 11;

signal = rand(2048, 128)*2 - 1; % white noise signal

coeffs = [delay_filter( -0.25, 40, K, fs, fc) ...
          delay_filter( -0.5, 40, K, fs, fc) ...
          delay_filter( -0.75, 40, K, fs, fc)];
      
ref = genRef(signal, coeffs);
out = Upsample4x(signal, coeffs);

max_deviation = max(max(abs(ref-out)))

end
%%

function ref = genRef(data, filters)
    channels = size(data,2)
    pad = (size(filters,1)-1)/2;
    paddedData = [data;zeros(pad,channels)];
    len = size(paddedData,1)*4;
    ref = zeros(len,channels);
    ref(1:4:end,:)=[zeros(pad,channels);data];
    for j = 2:4
        for i = 1:channels
            ref(j:4:end,i) = filter(filters(:,j-1),1,paddedData(:,i));
        end
    end
    ref = ref(pad*4+1:end,:);
end
